using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace MyVBAScript
{
	/// <summary>
	/// InputBox ժҪ˵
	/// </summary>
	public class dlgInputBox : System.Windows.Forms.Form
	{
        /// <summary>
        /// ʾһıԻ,ûȡ򷵻ؿ
        /// </summary>
        /// <param name="ParentWindow"></param>
        /// <param name="strTitle">Ի˵</param>
        /// <param name="strCaption">Ի</param>
        /// <param name="strDefaultValue">Ĭֵ</param>
        /// <returns>ûı,ȡ򷵻ؿ</returns>
        public static string InputBox(System.Windows.Forms.IWin32Window ParentWindow, string strTitle, string strCaption, string strDefaultValue)
        {
            using (dlgInputBox dlg = new dlgInputBox())
            {
                dlg.lblTitle.Text = strTitle;
                dlg.Text = strCaption;
                dlg.TextValue = strDefaultValue;
                if (dlg.ShowDialog(ParentWindow) == System.Windows.Forms.DialogResult.OK)
                {
                    return dlg.txtInput.Text;
                }
            }
            return null;
        }

		/// <summary>
		/// ʾһıԻ,ûȡ򷵻ؿ
		/// </summary>
		/// <param name="strTitle">Ի˵</param>
		/// <param name="strCaption">Ի</param>
		/// <param name="strDefaultValue">Ĭֵ</param>
		/// <returns>ûı,ȡ򷵻ؿ</returns>
		public static string InputBox( string strTitle , string strCaption , string strDefaultValue)
		{
			using( dlgInputBox dlg = new dlgInputBox())
			{
				dlg.lblTitle.Text	= strTitle ;
				dlg.Text			= strCaption ;
				dlg.TextValue		= strDefaultValue ;
				if( dlg.ShowDialog() == System.Windows.Forms.DialogResult.OK)
				{
					return dlg.txtInput.Text ;
				}
			}
			return null;
		}
         
		internal System.Windows.Forms.Label lblTitle;
		internal System.Windows.Forms.TextBox txtInput;
		internal System.Windows.Forms.Button cmdOK;
		internal System.Windows.Forms.Button cmdCancel;

		public string ErrorValueMsg = "ݴ!";
		private string strTextValue = "";

		public string InputTitle
		{
			get{ return this.lblTitle.Text ;}
			set{ this.lblTitle.Text = value;}
		}
		
		/// <summary>
		/// ֵַ
		/// </summary>
		public string TextValue
		{
			get{ return strTextValue ;}
			set{ strTextValue = value;}
		}

		/// <summary>
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;

		public dlgInputBox()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
			this.DialogResult = System.Windows.Forms.DialogResult.Cancel ;
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(dlgInputBox));
			this.lblTitle = new System.Windows.Forms.Label();
			this.txtInput = new System.Windows.Forms.TextBox();
			this.cmdOK = new System.Windows.Forms.Button();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// lblTitle
			// 
			this.lblTitle.AccessibleDescription = resources.GetString("lblTitle.AccessibleDescription");
			this.lblTitle.AccessibleName = resources.GetString("lblTitle.AccessibleName");
			this.lblTitle.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("lblTitle.Anchor")));
			this.lblTitle.AutoSize = ((bool)(resources.GetObject("lblTitle.AutoSize")));
			this.lblTitle.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("lblTitle.Dock")));
			this.lblTitle.Enabled = ((bool)(resources.GetObject("lblTitle.Enabled")));
			this.lblTitle.Font = ((System.Drawing.Font)(resources.GetObject("lblTitle.Font")));
			this.lblTitle.Image = ((System.Drawing.Image)(resources.GetObject("lblTitle.Image")));
			this.lblTitle.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("lblTitle.ImageAlign")));
			this.lblTitle.ImageIndex = ((int)(resources.GetObject("lblTitle.ImageIndex")));
			this.lblTitle.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("lblTitle.ImeMode")));
			this.lblTitle.Location = ((System.Drawing.Point)(resources.GetObject("lblTitle.Location")));
			this.lblTitle.Name = "lblTitle";
			this.lblTitle.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("lblTitle.RightToLeft")));
			this.lblTitle.Size = ((System.Drawing.Size)(resources.GetObject("lblTitle.Size")));
			this.lblTitle.TabIndex = ((int)(resources.GetObject("lblTitle.TabIndex")));
			this.lblTitle.Text = resources.GetString("lblTitle.Text");
			this.lblTitle.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("lblTitle.TextAlign")));
			this.lblTitle.Visible = ((bool)(resources.GetObject("lblTitle.Visible")));
			// 
			// txtInput
			// 
			this.txtInput.AccessibleDescription = resources.GetString("txtInput.AccessibleDescription");
			this.txtInput.AccessibleName = resources.GetString("txtInput.AccessibleName");
			this.txtInput.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("txtInput.Anchor")));
			this.txtInput.AutoSize = ((bool)(resources.GetObject("txtInput.AutoSize")));
			this.txtInput.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("txtInput.BackgroundImage")));
			this.txtInput.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("txtInput.Dock")));
			this.txtInput.Enabled = ((bool)(resources.GetObject("txtInput.Enabled")));
			this.txtInput.Font = ((System.Drawing.Font)(resources.GetObject("txtInput.Font")));
			this.txtInput.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("txtInput.ImeMode")));
			this.txtInput.Location = ((System.Drawing.Point)(resources.GetObject("txtInput.Location")));
			this.txtInput.MaxLength = ((int)(resources.GetObject("txtInput.MaxLength")));
			this.txtInput.Multiline = ((bool)(resources.GetObject("txtInput.Multiline")));
			this.txtInput.Name = "txtInput";
			this.txtInput.PasswordChar = ((char)(resources.GetObject("txtInput.PasswordChar")));
			this.txtInput.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("txtInput.RightToLeft")));
			this.txtInput.ScrollBars = ((System.Windows.Forms.ScrollBars)(resources.GetObject("txtInput.ScrollBars")));
			this.txtInput.Size = ((System.Drawing.Size)(resources.GetObject("txtInput.Size")));
			this.txtInput.TabIndex = ((int)(resources.GetObject("txtInput.TabIndex")));
			this.txtInput.Text = resources.GetString("txtInput.Text");
			this.txtInput.TextAlign = ((System.Windows.Forms.HorizontalAlignment)(resources.GetObject("txtInput.TextAlign")));
			this.txtInput.Visible = ((bool)(resources.GetObject("txtInput.Visible")));
			this.txtInput.WordWrap = ((bool)(resources.GetObject("txtInput.WordWrap")));
			this.txtInput.KeyDown += new System.Windows.Forms.KeyEventHandler(this.txtInput_KeyDown);
			// 
			// cmdOK
			// 
			this.cmdOK.AccessibleDescription = resources.GetString("cmdOK.AccessibleDescription");
			this.cmdOK.AccessibleName = resources.GetString("cmdOK.AccessibleName");
			this.cmdOK.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("cmdOK.Anchor")));
			this.cmdOK.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("cmdOK.BackgroundImage")));
			this.cmdOK.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("cmdOK.Dock")));
			this.cmdOK.Enabled = ((bool)(resources.GetObject("cmdOK.Enabled")));
			this.cmdOK.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("cmdOK.FlatStyle")));
			this.cmdOK.Font = ((System.Drawing.Font)(resources.GetObject("cmdOK.Font")));
			this.cmdOK.Image = ((System.Drawing.Image)(resources.GetObject("cmdOK.Image")));
			this.cmdOK.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("cmdOK.ImageAlign")));
			this.cmdOK.ImageIndex = ((int)(resources.GetObject("cmdOK.ImageIndex")));
			this.cmdOK.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("cmdOK.ImeMode")));
			this.cmdOK.Location = ((System.Drawing.Point)(resources.GetObject("cmdOK.Location")));
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("cmdOK.RightToLeft")));
			this.cmdOK.Size = ((System.Drawing.Size)(resources.GetObject("cmdOK.Size")));
			this.cmdOK.TabIndex = ((int)(resources.GetObject("cmdOK.TabIndex")));
			this.cmdOK.Text = resources.GetString("cmdOK.Text");
			this.cmdOK.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("cmdOK.TextAlign")));
			this.cmdOK.Visible = ((bool)(resources.GetObject("cmdOK.Visible")));
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.AccessibleDescription = resources.GetString("cmdCancel.AccessibleDescription");
			this.cmdCancel.AccessibleName = resources.GetString("cmdCancel.AccessibleName");
			this.cmdCancel.Anchor = ((System.Windows.Forms.AnchorStyles)(resources.GetObject("cmdCancel.Anchor")));
			this.cmdCancel.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("cmdCancel.BackgroundImage")));
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Dock = ((System.Windows.Forms.DockStyle)(resources.GetObject("cmdCancel.Dock")));
			this.cmdCancel.Enabled = ((bool)(resources.GetObject("cmdCancel.Enabled")));
			this.cmdCancel.FlatStyle = ((System.Windows.Forms.FlatStyle)(resources.GetObject("cmdCancel.FlatStyle")));
			this.cmdCancel.Font = ((System.Drawing.Font)(resources.GetObject("cmdCancel.Font")));
			this.cmdCancel.Image = ((System.Drawing.Image)(resources.GetObject("cmdCancel.Image")));
			this.cmdCancel.ImageAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("cmdCancel.ImageAlign")));
			this.cmdCancel.ImageIndex = ((int)(resources.GetObject("cmdCancel.ImageIndex")));
			this.cmdCancel.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("cmdCancel.ImeMode")));
			this.cmdCancel.Location = ((System.Drawing.Point)(resources.GetObject("cmdCancel.Location")));
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("cmdCancel.RightToLeft")));
			this.cmdCancel.Size = ((System.Drawing.Size)(resources.GetObject("cmdCancel.Size")));
			this.cmdCancel.TabIndex = ((int)(resources.GetObject("cmdCancel.TabIndex")));
			this.cmdCancel.Text = resources.GetString("cmdCancel.Text");
			this.cmdCancel.TextAlign = ((System.Drawing.ContentAlignment)(resources.GetObject("cmdCancel.TextAlign")));
			this.cmdCancel.Visible = ((bool)(resources.GetObject("cmdCancel.Visible")));
			this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
			// 
			// dlgInputBox
			// 
			this.AccessibleDescription = resources.GetString("$this.AccessibleDescription");
			this.AccessibleName = resources.GetString("$this.AccessibleName");
			this.AutoScaleBaseSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScaleBaseSize")));
			this.AutoScroll = ((bool)(resources.GetObject("$this.AutoScroll")));
			this.AutoScrollMargin = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMargin")));
			this.AutoScrollMinSize = ((System.Drawing.Size)(resources.GetObject("$this.AutoScrollMinSize")));
			this.BackgroundImage = ((System.Drawing.Image)(resources.GetObject("$this.BackgroundImage")));
			this.CancelButton = this.cmdCancel;
			this.ClientSize = ((System.Drawing.Size)(resources.GetObject("$this.ClientSize")));
			this.Controls.Add(this.cmdCancel);
			this.Controls.Add(this.cmdOK);
			this.Controls.Add(this.txtInput);
			this.Controls.Add(this.lblTitle);
			this.Enabled = ((bool)(resources.GetObject("$this.Enabled")));
			this.Font = ((System.Drawing.Font)(resources.GetObject("$this.Font")));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.ImeMode = ((System.Windows.Forms.ImeMode)(resources.GetObject("$this.ImeMode")));
			this.Location = ((System.Drawing.Point)(resources.GetObject("$this.Location")));
			this.MaximizeBox = false;
			this.MaximumSize = ((System.Drawing.Size)(resources.GetObject("$this.MaximumSize")));
			this.MinimizeBox = false;
			this.MinimumSize = ((System.Drawing.Size)(resources.GetObject("$this.MinimumSize")));
			this.Name = "dlgInputBox";
			this.RightToLeft = ((System.Windows.Forms.RightToLeft)(resources.GetObject("$this.RightToLeft")));
			this.ShowInTaskbar = false;
			this.StartPosition = ((System.Windows.Forms.FormStartPosition)(resources.GetObject("$this.StartPosition")));
			this.Text = resources.GetString("$this.Text");
			this.Load += new System.EventHandler(this.dlgInputBox_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			strTextValue = this.txtInput.Text ;
			this.DialogResult = System.Windows.Forms.DialogResult.OK ;
			this.Close();
		}

		private void cmdCancel_Click(object sender, System.EventArgs e)
		{
			this.DialogResult = System.Windows.Forms.DialogResult.Cancel ;
			this.Close();
		}

		private void txtInput_KeyDown(object sender, KeyEventArgs e)
		{
			if( e.KeyCode == System.Windows.Forms.Keys.Enter )
				cmdOK_Click(null,null);
		}

		private void dlgInputBox_Load(object sender, System.EventArgs e)
		{
			this.txtInput.Text = strTextValue ;
		}

		//		public void SetPasswordMode(bool bolSet )
		//		{
		//			if( bolSet )
		//				this.txtInput.PasswordChar = '*';
		//			else
		//				this.txtInput.PasswordChar = ' ';
		//		}
	}
}